package com.fjhx.xmhjc.controller.carousel;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.carousel.vo.CarouselManagerVo;
import com.fjhx.xmhjc.entity.carousel.dto.CarouselManagerSelectDto;
import com.fjhx.xmhjc.entity.carousel.dto.CarouselManagerDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.xmhjc.service.carousel.CarouselManagerService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * <p>
 * 轮播图管理 前端控制器
 * </p>
 *
 * @author hj
 * @since 2023-11-19
 */
@RestController
@RequestMapping("/carouselManager")
public class CarouselManagerController {

    @Autowired
    private CarouselManagerService carouselManagerService;

    /**
     * 轮播图管理列表
     */
    @PostMapping("/list")
    public List<CarouselManagerVo> list(@RequestBody CarouselManagerSelectDto dto) {
        return carouselManagerService.getList(dto);
    }

    /**
     * 轮播图管理分页
     */
    @PostMapping("/page")
    public Page<CarouselManagerVo> page(@RequestBody CarouselManagerSelectDto dto) {
        return carouselManagerService.getPage(dto);
    }

    /**
     * 轮播图管理明细
     */
    @PostMapping("/detail")
    public CarouselManagerVo detail(@RequestBody BaseSelectDto dto) {
        return carouselManagerService.detail(dto.getId());
    }

    /**
     * 轮播图管理新增
     */
    @PostMapping("/add")
    public void add(@RequestBody CarouselManagerDto carouselManagerDto) {
        carouselManagerService.add(carouselManagerDto);
    }

    /**
     * 轮播图管理编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody CarouselManagerDto carouselManagerDto) {
        carouselManagerService.edit(carouselManagerDto);
    }

    /**
     * 轮播图管理编辑
     */
    @PostMapping("/changeStatus")
    public void changeStatus(@RequestBody CarouselManagerDto carouselManagerDto) {
        carouselManagerService.changeStatus(carouselManagerDto);
    }

    /**
     * 轮播图管理删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        carouselManagerService.delete(dto.getId());
    }

}
