package com.fjhx.xmhjc.service.about.impl;

import com.fjhx.file.entity.FileInfoVo;
import com.fjhx.file.utils.ObsFileUtil;
import com.fjhx.xmhjc.entity.about.po.AboutUsBaseInfo;
import com.fjhx.xmhjc.entity.about.vo.AboutUsBootInfoVo;
import com.fjhx.xmhjc.entity.about.vo.AboutUsBasicInfoVo;
import com.fjhx.xmhjc.mapper.about.AboutUsBaseInfoMapper;
import com.fjhx.xmhjc.service.about.AboutUsBaseInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.about.vo.AboutUsBaseInfoVo;
import com.fjhx.xmhjc.entity.about.dto.AboutUsBaseInfoSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.about.dto.AboutUsBaseInfoDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;


/**
 * <p>
 * 关于我们-基础信息 服务实现类
 * </p>
 *
 * @author lqh
 * @since 2023-11-12
 */
@Service
public class AboutUsBaseInfoServiceImpl extends ServiceImpl<AboutUsBaseInfoMapper, AboutUsBaseInfo> implements AboutUsBaseInfoService {

    @Override
    public Page<AboutUsBaseInfoVo> getPage(AboutUsBaseInfoSelectDto dto) {
        IWrapper<AboutUsBaseInfo> wrapper = getWrapper();
        wrapper.orderByDesc("aubi", AboutUsBaseInfo::getId);
        Page<AboutUsBaseInfoVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public AboutUsBaseInfoVo detail(Long id) {
        AboutUsBaseInfo AboutUsBaseInfo = this.getById(id);
        AboutUsBaseInfoVo result = BeanUtil.toBean(AboutUsBaseInfo, AboutUsBaseInfoVo.class);
        return result;
    }

    @Override
    public void add(AboutUsBaseInfoDto aboutUsBaseInfoDto) {
        this.save(aboutUsBaseInfoDto);

        // 公司简介图片
        ObsFileUtil.saveFile(aboutUsBaseInfoDto.getCompanyCoverList(), aboutUsBaseInfoDto.getId(), 1);
        ObsFileUtil.saveFile(aboutUsBaseInfoDto.getGzhQrCodeList(), aboutUsBaseInfoDto.getId(), 2);
    }

    @Override
    public void edit(AboutUsBaseInfoDto aboutUsBaseInfoDto) {
        this.updateById(aboutUsBaseInfoDto);
        // 公司简介图片
        ObsFileUtil.editFile(aboutUsBaseInfoDto.getCompanyCoverList(), aboutUsBaseInfoDto.getId(), 1);
        ObsFileUtil.editFile(aboutUsBaseInfoDto.getGzhQrCodeList(), aboutUsBaseInfoDto.getId(), 2);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

    @Override
    public AboutUsBaseInfoVo detailDefault() {
        AboutUsBaseInfo aboutUsBaseInfo = new AboutUsBaseInfo();
        List<AboutUsBaseInfo> list = lambdaQuery().list();
        if (!list.isEmpty()){
            aboutUsBaseInfo = list.get(0);
        }
        AboutUsBaseInfoVo result = BeanUtil.toBean(aboutUsBaseInfo, AboutUsBaseInfoVo.class);
        return result;
    }


    @Override
    public AboutUsBasicInfoVo detailDefaultByOpen() {

        AboutUsBaseInfo aboutUsBaseInfo = new AboutUsBaseInfo();
        List<AboutUsBaseInfo> list = lambdaQuery().list();
        if (!list.isEmpty()){
            aboutUsBaseInfo = list.get(0);
        }
        AboutUsBasicInfoVo result = BeanUtil.toBean(aboutUsBaseInfo, AboutUsBasicInfoVo.class);

        //获取公司简介图片
        List<Long> businessIdList = new ArrayList<>();
        businessIdList.add(aboutUsBaseInfo.getId());
        Map<Long, List<FileInfoVo>> fileMap = ObsFileUtil.getFileMap(businessIdList, 1);
        result.setCompanyCoverList(fileMap.get(aboutUsBaseInfo.getId()));

        return result;
    }

    @Override
    public AboutUsBootInfoVo detailBootInfoByOpen() {

        AboutUsBaseInfo aboutUsBaseInfo = new AboutUsBaseInfo();
        List<AboutUsBaseInfo> list = lambdaQuery().list();
        if (!list.isEmpty()){
            aboutUsBaseInfo = list.get(0);
        }
        AboutUsBootInfoVo result = BeanUtil.toBean(aboutUsBaseInfo, AboutUsBootInfoVo.class);

        //获取公众号图片
        List<Long> businessIdList = new ArrayList<>();
        businessIdList.add(aboutUsBaseInfo.getId());
        Map<Long, List<FileInfoVo>> fileMap = ObsFileUtil.getFileMap(businessIdList, 2);
        result.setGzhQrCodeList(fileMap.get(aboutUsBaseInfo.getId()));

        return result;
    }
}
